program functionDemo(input, output, stderr);

{$mode objfpc}

type
	bodyAttributes = record
		surfaceArea: real;
		volume: real;
	end;

// in assembly language:
// return type does not fit into accumulator => use __result macro
function sphere(const radius: real): bodyAttributes;
{$ifdef CPUx86_64}
assembler;
{$asmMode intel}
const
	three: longint = 3;
	four: longint = 4;
var
	r: real;
asm
	pextrq r, radius, 0
	mov rax, @result
	fld r             // radius
	fld st(0)         // radius radius
	fild four         // 4 radius radius
	fldpi             // pi 4 radius radius
	fmul              // 4*pi radius radius
	fxch              // radius 4*pi radius
	fld st(0)         // radius radius 4*pi radius
	fmul              // radius^2 4*pi radius
	fmul              // 4*pi*radius^2 radius
	fst [rax].bodyAttributes.surfaceArea
	fmul              // 4*pi*radius^3
	fild three        // 3 4*pi*radius^3
	fdivp             // 4/3*pi*radius^3
	fst [rax].bodyAttributes.volume
end;
{$else}
begin
	sphere.surfaceArea := 4 * pi() * sqr(radius);
	sphere.volume := 4 / 3 * pi() * sqr(radius) * abs(radius);
end;
{$endif}

begin
	writeLn(sphere(2.0).surfaceArea);
end.
